using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Ato.EN.IntegrationServices.CodeGenerationLDGList2023
{
    /// <summary>
    /// LDGList
    /// </summary>
    [DataContract(Name = "LDGList", Namespace = "http://www.sbr.gov.au/ato/ldglist")]
    public class LDGList
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public INT INT { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 2)]
        public RP RP { get; set; }
    }

    /// <summary>
    /// Intermediary
    /// </summary>
    [DataContract(Name = "INT", Namespace = "http://www.sbr.gov.au/ato/ldglist")]
    public class INT
    {

        /// <summary>
        /// Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Tax Agent Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAgentNumberId { get; set; }
    }

    [CollectionDataContract(Name = "LodgmentStatusCCollection", Namespace = "http://www.sbr.gov.au/ato/ldglist", ItemName = "LodgmentStatusC")]
    public class LodgmentStatusCCollection : List<string> { }

    /// <summary>
    /// Search Criteria
    /// </summary>
    [DataContract(Name = "SearchCriteria", Namespace = "http://www.sbr.gov.au/ato/ldglist")]
    public class SearchCriteria
    {

        /// <summary>
        /// Account identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxAccountId { get; set; }

        /// <summary>
        /// Account sequence number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? TaxAccountSequenceN { get; set; }

        /// <summary>
        /// Account type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TaxAccountTypeC { get; set; }

        /// <summary>
        /// Role type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string TaxRoleTypeC { get; set; }

        /// <summary>
        /// Form category
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string CategoryC { get; set; }

        /// <summary>
        /// Period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public DateTime? PeriodStartD { get; set; }

        /// <summary>
        /// Period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public DateTime? PeriodEndD { get; set; }

        /// <summary>
        /// Lodgment status
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public LodgmentStatusCCollection LodgmentStatusCCollection { get; set; }
    }

    /// <summary>
    /// Pagination
    /// </summary>
    [DataContract(Name = "Pagination", Namespace = "http://www.sbr.gov.au/ato/ldglist")]
    public class Pagination
    {

        /// <summary>
        /// Record limit
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public decimal? InteractionRecordLimitCt { get; set; }

        /// <summary>
        /// Start account identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAccountId { get; set; }

        /// <summary>
        /// Start account type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TaxAccountTypeC { get; set; }

        /// <summary>
        /// Start role type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string TaxRoleTypeC { get; set; }

        /// <summary>
        /// Start transaction identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string BusinessDocumentGovernmentGeneratedId { get; set; }

        /// <summary>
        /// Start form created timestamp
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public DateTime? BusinessDocumentCreationDt { get; set; }

        /// <summary>
        /// Start form received date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public DateTime? LodgmentReceivedD { get; set; }

        /// <summary>
        /// Start period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public DateTime? PeriodStartD { get; set; }

        /// <summary>
        /// Start period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public DateTime? PeriodEndD { get; set; }

        /// <summary>
        /// Start period sequence number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public decimal? StatementPeriodSequenceN { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/ldglist")]
    public class RP
    {

        /// <summary>
        /// Tax File Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string AustralianBusinessNumberId { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 3)]
        public SearchCriteria SearchCriteria { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public Pagination Pagination { get; set; }
    }
}

