using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Ato.EN.IntegrationServices.CodeGenerationLDGListResponse2023
{
    /// <summary>
    /// LDGListResponse
    /// </summary>
    [DataContract(Name = "LDGListResponse", Namespace = "http://www.sbr.gov.au/ato/ldglistresponse")]
    public class LDGListResponse
    {

        [DataMember(EmitDefaultValue = false, Order = 1)]
        public RP RP { get; set; }
    }

    /// <summary>
    /// Lodgment Details
    /// </summary>
    [CollectionDataContract(Name = "LodgmentDetailsCollection", Namespace = "http://www.sbr.gov.au/ato/ldglistresponse", ItemName="LodgmentDetails" )]
    public class LodgmentDetailsCollection: List<LodgmentDetails> {}

    /// <summary>
    /// Lodgment Details
    /// </summary>
    [DataContract(Name = "LodgmentDetails", Namespace = "http://www.sbr.gov.au/ato/ldglistresponse")]
    public class LodgmentDetails
    {

        /// <summary>
        /// Client identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxAccountId { get; set; }

        /// <summary>
        /// Account sequence number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public decimal? TaxAccountSequenceN { get; set; }

        /// <summary>
        /// Account type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TaxAccountTypeC { get; set; }

        /// <summary>
        /// Role type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string TaxRoleTypeC { get; set; }

        /// <summary>
        /// Period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string PeriodStartD { get; set; }

        /// <summary>
        /// Period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string PeriodEndD { get; set; }

        /// <summary>
        /// Form category
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string CategoryC { get; set; }

        /// <summary>
        /// Form name description
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public string NameT { get; set; }

        /// <summary>
        /// Activity statement form type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public string TypeC { get; set; }

        /// <summary>
        /// Form variation
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 10)]
        public string TypeVariationC { get; set; }

        /// <summary>
        /// Form year
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 11)]
        public int? FinancialY { get; set; }

        /// <summary>
        /// Period sequence number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 12)]
        public string StatementPeriodSequenceN { get; set; }

        /// <summary>
        /// Transaction identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 13)]
        public string BusinessDocumentGovernmentGeneratedId { get; set; }

        /// <summary>
        /// Transaction type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 14)]
        public string TransactionTypeC { get; set; }

        /// <summary>
        /// Lodgment status
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 15)]
        public string StatusC { get; set; }

        /// <summary>
        /// Lodgment receipt identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 16)]
        public string ReceiptId { get; set; }

        /// <summary>
        /// Form received date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 17)]
        public string ReceivedD { get; set; }

        /// <summary>
        /// Form processing status
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 18)]
        public string ProcessStatusC { get; set; }

        /// <summary>
        /// Lodgment due date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 19)]
        public string DueD { get; set; }

        /// <summary>
        /// Payment due date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 20)]
        public string PaymentRecordDueD { get; set; }

        /// <summary>
        /// Lodgment channel
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 21)]
        public string ChannelC { get; set; }

        /// <summary>
        /// ATO processed liabilities for an STP reporter's Activity Statements
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 22)]
        public bool? TaxLiabilityProcessedI { get; set; }

        /// <summary>
        /// Due or refundable amount
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 23)]
        public decimal? StatementSummaryNetA { get; set; }
    }

    /// <summary>
    /// Pagination
    /// </summary>
    [DataContract(Name = "Pagination", Namespace = "http://www.sbr.gov.au/ato/ldglistresponse")]
    public class Pagination
    {

        /// <summary>
        /// Next account identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxAccountId { get; set; }

        /// <summary>
        /// Next account type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string TaxAccountTypeC { get; set; }

        /// <summary>
        /// Next role type
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public string TaxRoleTypeC { get; set; }

        /// <summary>
        /// Next transaction identifier
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 4)]
        public string BusinessDocumentGovernmentGeneratedId { get; set; }

        /// <summary>
        /// Next form created timestamp
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 5)]
        public string BusinessDocumentCreationDt { get; set; }

        /// <summary>
        /// Next form received date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 6)]
        public string LodgmentReceivedD { get; set; }

        /// <summary>
        /// Next period start date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 7)]
        public string PeriodStartD { get; set; }

        /// <summary>
        /// Next period end date
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 8)]
        public string PeriodEndD { get; set; }

        /// <summary>
        /// Next period sequence number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 9)]
        public string StatementPeriodSequenceN { get; set; }
    }

    /// <summary>
    /// Reporting Party
    /// </summary>
    [DataContract(Name = "RP", Namespace = "http://www.sbr.gov.au/ato/ldglistresponse")]
    public class RP
    {

        /// <summary>
        /// Tax File Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 1)]
        public string TaxFileNumberId { get; set; }

        /// <summary>
        /// Australian Business Number
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 2)]
        public string AustralianBusinessNumberId { get; set; }

        /// <summary>
        /// Number of Lodgments
        /// </summary>
        [DataMember(EmitDefaultValue = false, Order = 3)]
        public decimal? InteractionRecordCt { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 4)]
        public LodgmentDetailsCollection LodgmentDetailsCollection { get; set; }

        [DataMember(EmitDefaultValue = false, Order = 5)]
        public Pagination Pagination { get; set; }
    }
}
 
